# remirepo/Fedora spec file for php-zendframework-zend-inputfilter
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    799ad48ed1666d3c62126fec73dd20453b3a9e4d
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-inputfilter
%global php_home     %{_datadir}/php
%global library      InputFilter
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.8.3
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-filter)         >= 2.6    with php-autoloader(%{gh_owner}/zend-filter)         < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.5    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.10 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
# remirepo:10
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-filter)         <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-filter)         >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager) <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.10
%endif
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.23 || ^6.4.3",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires:  phpunit6 >= 6.4.3
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-filter": "^2.6",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
#        "zendframework/zend-validator": "^2.10.1",
#        "zendframework/zend-servicemanager": "^2.7.10 || ^3.3.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-filter)         >= 2.6    with php-autoloader(%{gh_owner}/zend-filter)         < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.5    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.10 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
# remirepo:10
%else
Requires:       php-autoloader(%{gh_owner}/zend-filter)         <  3
Requires:       php-autoloader(%{gh_owner}/zend-filter)         >= 2.6
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-validator)      <  3
Requires:       php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) <  4
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.10
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.5
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\InputFilter component can be used to filter and validate generic sets
of input data. For instance, you could use it to filter $_GET or $_POST values,
CLI arguments, etc.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Filter/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/ServiceManager/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php70 php71 php72 php73; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit6 --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Dec 14 2018 Remi Collet <remi@remirepo.net> - 2.8.3-2
- update to 2.8.3

* Tue May 15 2018 Remi Collet <remi@remirepo.net> - 2.8.2-2
- update to 2.8.2
- use range dependencies on F27+

* Tue Jan 23 2018 Remi Collet <remi@remirepo.net> - 2.8.1-2
- Update to 2.8.1
- add dependency on zend-servicemanager
- only use phpunit6

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.8.0-2
- switch from zend-loader to fedora/autoloader

* Tue Dec  5 2017 Remi Collet <remi@remirepo.net> - 2.8.0-1
- Update to 2.8.0
- raise dependency on zend-validator 2.10.1

* Wed Nov  8 2017 Remi Collet <remi@remirepo.net> - 2.7.5-1
- Update to 2.7.5

* Tue Oct 24 2017 Remi Collet <remi@remirepo.net> - 2.7.4-1
- fix FTBFS from Koschei, add patch for PHP 7.2 from
  https://github.com/zendframework/zend-inputfilter/pull/150

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.7.4-1
- Update to 2.7.4
- raise dependency on PHP 5.6
- use phpunit6 on F26+
- open https://github.com/zendframework/zend-inputfilter/pull/141
  fix for PHPUnit 6

* Fri Sep  2 2016 Remi Collet <remi@fedoraproject.org> - 2.7.3-1
- update to 2.7.3

* Sun Jun 12 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Fri Apr  8 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Thu Apr  7 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Fri Feb 19 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-stdlib >= 2.7
- skip test suite with PHPUnit >= 5

* Fri Sep  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.5-1
- update to 2.5.5
- raise dependency on zend-validator ^2.5.3
- raise build dependency on PHPUnit ^4.5

* Wed Aug 12 2015 Remi Collet <remi@fedoraproject.org> - 2.5.4-1
- update to 2.5.4

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- initial package
